/* A silly little calculator implemented in Object Rexx using
   Java components for the UI. 2001-05-02, 2003-01-23, ---rgf, 2003-05-10
   ("bsf\samples\bsh\calculator.js" served as an example)       */

if      BsfInvokedBy()=1 then say "This Rexx program was invoked by Java!"
else if BsfInvokedBy()=2 then say "This Rexx program was invoked by Rexx, JVM loaded by Rexx!"
else                          say "No JVM present, we got troubles ..."

.bsf~import("awtTextField",     "java.awt.TextField")
.bsf~import("awtLabel",         "java.awt.Label")

f = .bsf~new("java.awt.Frame", "BSH Calculator (Object REXX)")
f~bsf.addEventListener("window", "windowClosing", "call bsf 'exit'")

f1 = .awtTextField~new(20)
f1~bsf.addEventListener("action", "", "call doMath /* action event */")

f2 = .awtTextField~new(20)
f2~bsf.addEventListener("text", "", "call doMath /* text event */")

p = .bsf~new( "java.awt.Panel") ~~setLayout(.bsf~new("java.awt.GridLayout", 2, 2))
p ~~add(.awtLabel~new("Enter operand")) ~~add(f1)
p ~~add(.awtLabel~new("Enter operand")) ~~add(f2)

f ~~add("North", p) ~~add("Center", .awtLabel~new("Results:"))

p =  .bsf~new("java.awt.Panel") ~~setLayout(.bsf~new("java.awt.GridLayout", 4, 2))

sum= .awtTextField~new(20)
p ~~add(.awtLabel~new("Sum")) ~~add(sum)

diff= .awtTextField~new(20)
p ~~add(.awtLabel~new("Difference")) ~~add(diff)

prod= .awtTextField~new(20)
p ~~add(.awtLabel~new("Product")) ~~add(prod)

quo = .awtTextField~new(20)
p ~~add(.awtLabel~new("Quotient")) ~~add(quo)

f ~~add("South", p) ~~pack ~~show ~~toFront

do forever
   -- a=bsf("pollEventText")
   a=.bsf~pollEventText
   say "... received: ["a"]"
   interpret a
end
exit

getField: procedure
   use arg f
   t=f~getText
   if t="" then return 0
   return t

doMath:
   n1 = getField(f1); if n1="-" then n1=-1;else if n1="+" then n1=1
   n2 = getField(f2); if n2="-" then n2=-1;else if n2="+" then n2=1
   sum ~setText(n1+n2)
   diff~setText(n1-n2)
   prod~setText(n1*n2)
   if n2=0 then quo~setText("DIVISION by 0 !!!")
           else quo~setText(n1/n2)
   return

::requires BSF.CLS    -- get Object Rexx wrapper support
